searchNodes=[{"doc":"Generates SnowflakeId's. This struct implements the Enumerable protocol, so you can use this with all the functions from Enum and Stream modules. This implementation is functional and does not use any GenServer to store the state. # override the time function for the test iex&gt; get_time = fn -&gt; 1630163558780 end iex&gt; generator = SnowflakeId . new ( 1 , 1 , get_time : get_time ) iex&gt; Enum . at ( generator , 0 ) 6837401535245324288 iex&gt; generator |&gt; Enum . at ( 0 ) |&gt; Integer . to_string ( 2 ) &quot;101111011100011010101000111100001011111000000100001000000000000&quot; #^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^xxxxxyyyyyzzzzzzzzzzzz #^: timestamp #x: machine_id #y: node_id #z: index More realistic example: iex&gt; my_data = ...&gt; SnowflakeId . new ( 1 , 1 ) ...&gt; |&gt; Enum . take ( 10 ) ...&gt; |&gt; Enum . map ( fn id -&gt; ...&gt; # insert your data in your database ...&gt; %{ id : id , name : &quot;my_id_ \#{ id } &quot; } ...&gt; end ) iex&gt; length ( my_data ) 10 If you want to not use the Enumerable protocol you can do it yourself by: # override the time function for the test iex&gt; get_time = fn -&gt; 1630163558780 end iex&gt; generator = SnowflakeId . new ( 1 , 1 , get_time : get_time ) iex&gt; SnowflakeId . format_id ( generator ) 6837401535245324288 iex&gt; generator = SnowflakeId . next ( generator ) iex&gt; SnowflakeId . format_id ( generator ) 6837401535245324289","ref":"SnowflakeId.html","title":"SnowflakeId","type":"module"},{"doc":"Format the struct to return a id","ref":"SnowflakeId.html#format_id/1","title":"SnowflakeId.format_id/1","type":"function"},{"doc":"Create a new SnowflakeId struct options: :get_time : (-&gt; integer) override the function to get the current timestamp, this function should return the time since an epoch in milliseconds. by defaut it uses :os.system_time(:millisecond) :bulk : boolean Don't check the time on every iteration, but only when the maximum amount of indexes is filled, which is 0..4095 This can be handy if you know you are going to generate a lot of indexes at once.","ref":"SnowflakeId.html#new/3","title":"SnowflakeId.new/3","type":"function"},{"doc":"Update the struct to the next identifier","ref":"SnowflakeId.html#next/1","title":"SnowflakeId.next/1","type":"function"},{"doc":"Default function to return the current timestamp in milliseconds","ref":"SnowflakeId.html#os_system_time/0","title":"SnowflakeId.os_system_time/0","type":"function"},{"doc":"Create a new SnowflakeId struct but with some extra checks. For more info check new/3","ref":"SnowflakeId.html#try_new/3","title":"SnowflakeId.try_new/3","type":"function"},{"doc":"","ref":"SnowflakeId.html#t:opts/0","title":"SnowflakeId.opts/0","type":"type"},{"doc":"","ref":"SnowflakeId.html#t:t/0","title":"SnowflakeId.t/0","type":"type"}]